﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Encodings.ParameterConfigurationEncoding.Views {
  /// <summary>
  /// used to display messages in a viewhost
  /// </summary>
  public class MessageItem : NamedItem {
    public override bool CanChangeDescription { get { return !initialized; } }
    public override bool CanChangeName { get { return !initialized; } }
    private bool initialized = false;

    public MessageItem()
      : base() {
      this.Name = "MessageItem";
    }
    public MessageItem(string message)
      : base(message, "This item represents a message to the user.") {
      this.initialized = true;
    }
    protected MessageItem(MessageItem original, Cloner cloner)
      : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new MessageItem(this, cloner);
    }
  }
}
